﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private PE As PhoneEvents
	Private PhoneId As PhoneId
	Private sdk as Phone
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	PE.InitializeWithPhoneState("PE",PhoneId)
	'SmsIncoming.Initialize("SmsInterceptor")
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.AutomaticForegroundMode=Service.AUTOMATIC_FOREGROUND_NEVER
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub PE_PhoneStateChanged (State As String, IncomingNumber As String, Intent As Intent)
	Log("Phone state: " & State)
	
	If State = "RINGING" Then 'OFFHOOK
		Sleep(5000)
		ENDCALL
	End If
End Sub

Sub ENDCALL
	If sdk.SdkVersion>27 Then 
		Dim ctxt As JavaObject
		ctxt.InitializeContext
		Dim tmm As JavaObject = ctxt.RunMethod("getSystemService", Array("telecom"))
		Dim success As Boolean = tmm.RunMethod("endCall", Null)
		If success=False Then
			Dim success As Boolean = tmm.RunMethod("endCall", Null)
		End If
	Else
		Dim r As Reflector
		r.Target = r.GetContext
		Dim TelephonyManager, TelephonyInterface As Object
		TelephonyManager = r.RunMethod2("getSystemService", "phone", "java.lang.String")
		r.Target = TelephonyManager
		TelephonyInterface = r.RunMethod("getITelephony")
		r.Target = TelephonyInterface
		r.RunMethod("endCall")
	End If
End Sub
